stock StartDatabase(){
	//I can't think of nothing, since the DB mamager is going to taking care of everything
}

stock StartDbNatives(){
	CreateNative("ZM_SetMaxLevel", ChangeMaxLevel);
	CreateNative("ZM_StartUpgrate", StartUpgrate);
	CreateNative("ZM_GetLevel", Native_GetUserLevel);
}

//String:DbRowName, String:Name, String:Description, Int:Maxlevel
public StartUpgrate(Handle:plugin,argc){
 	if(argc != 4)
 		return -1;
 		
 	decl String:Rowname[32], String:Name[32], String:Description[256];
 	
 	GetNativeString(1, Rowname, sizeof(Rowname));
 	GetNativeString(2, Name, sizeof(Name));
 	GetNativeString(3, Description, sizeof(Description));
 	
 	return CreateNewUpgrate(Rowname, Name, Description, GetNativeCell(4));
}

//Player, columnid
public Native_GetUserLevel(Handle:plugin,argc){
 	if(argc != 2)
 		return -1;
 	
 	return GetUpgrateLevel(GetNativeCell(1),GetNativeCell(2));
}

stock CreateNewUpgrate(const String:Rowname[], const String:Name[], const String:Description[], maxlevel){
 	decl String:temp[33];
	if(strlen(Rowname) > 33){
		LogMessage("Attetion! the RowName may not be longer than 32 charcters");
		return -1;
	}
	
	for(new i = 0; i < GetUpgrateCount() ; i++){
	 	GetArrayString(Upgrates[UPGRATE_NAME], i, temp, sizeof(temp));
		if(StrEqual(temp,Rowname)){
		 	//For some reason, if guy is calling the same func two times...
			return i;
		}
	}
	
 
 	new updinfo [ UPGRATE_INFO_COUNT ];
	updinfo[UPGRATE_INFO_ID] = DB_GetColumnId(Rowname, true, true);
 	
 	if(updinfo[UPGRATE_INFO_ID] == -1)
	 	return -1;
	
	#if DEBUG == 1	
		LogMessage("Adding new row: %s", Name);
	#endif
	 	
	updinfo[UPGRATE_INFO_MAXLEVEL] = maxlevel;
	updinfo[UPGRATE_INFO_ENABLED] = true;
	
	
	//Well, if eveeything is beeing pushed togheder, nothing will get left behind
	PushArrayArray(Upgrates[UPGRATE_INFO]     , updinfo);
	PushArrayString(Upgrates[UPGRATE_NAME]   , Name);
	PushArrayString(Upgrates[UPGRATE_DBNAME] , Rowname);
	//There is no need to store row name...
	return PushArrayString(Upgrates[UPGRATE_DESCRIPTION], Description);
}

//Set MaxLevel, int:Id, int: Maxlevel
public ChangeMaxLevel(Handle:plugin,argc){
 	if(argc == 2) 		
 		SetMaxLevel( GetNativeCell(1), GetNativeCell(2));	
}

//Set a upgrate on/off
//id, bool: enable/disable
public ToogleUpgrate(Handle:plugin,argc){
 	if(argc == 2){
		SetArrayCell(Upgrates[UPGRATE_INFO] , GetNativeCell(1), GetNativeCell(2), UPGRATE_INFO_ENABLED); 
	}	
}

stock GetUpgrateStatus(id){
	return GetArrayCell(Upgrates[UPGRATE_INFO], id, UPGRATE_INFO_ENABLED) ;
}


public SetMaxLevel(id, newmaxlevel){
	SetArrayCell(Upgrates[UPGRATE_INFO] , id, newmaxlevel, UPGRATE_INFO_MAXLEVEL);
}

//Get the level upgrate of a client
public GetUpgrateLevel(client, id){
	return DB_GetColumn( client, GetArrayCell(Upgrates[UPGRATE_INFO], id, UPGRATE_INFO_ID) );
}

//Get the maximun level a upgrate can go to to
public GetUpgrateMax(id){
	return GetArrayCell(Upgrates[UPGRATE_INFO], id, UPGRATE_INFO_MAXLEVEL)
}

//Get the name of a upgrate
public GetUpgrateName(id, String:name[], maxlen){
	GetArrayString(Upgrates[UPGRATE_NAME], id, name, maxlen);
}

//Get the description a upgrate has
public GetUpgrateDesc(id, String:desc[], maxlen){
	GetArrayString(Upgrates[UPGRATE_DESCRIPTION], id, desc, maxlen);
}

//Get the total number of upgrates there is
public GetUpgrateCount(){
	return GetArraySize(Upgrates[UPGRATE_INFO]);
}

//Set Upgrate Level
stock SetUpgrateLevel(client, id, level, bool:add=false, bool:recalculate=true){
	DB_SetInfo( client, GetArrayCell(Upgrates[UPGRATE_INFO], id, UPGRATE_INFO_ID), level , add);
	if(recalculate)
		CalculateFreePoints(client);
}

//Sets player XP and calculates new level
stock SetPlayerXP(client, xp, bool:add=false){
 	//LogMessage("Setting player(%d) xp to: %d , add: %d", client, xp, add);
	DB_SetInfo( client, Db_playerxp, xp , add);
	CalculateFreePoints(client);
}

stock GetPlayerXP(client){
	return DB_GetColumn( client, Db_playerxp );
}


//Get the amount of points has yet not spended
stock Getfreepoints(client){
	if(ClientFreePoints[client] == -1)
		CalculateFreePoints(client);
	
	return ClientFreePoints[client];
}

stock CalculateFreePoints(client){ 
 	//Level 1 has no points
	new temp = GetPlayerLevel(client) - 1,totalcount = GetUpgrateCount();
	if(temp < 0){
		SetPlayerLevel(client, 1);
		ClientFreePoints[client] = 0;
		return;	
	}
	
	
	for(new i = 0; i < totalcount ; i++){
		temp -= GetUpgrateLevel(client, i);
	}
	
	//holy ****! He used more points than he can actually use
	if(temp < 0){
	 	//I do not like this function
		//OverLoadLevel(client, GetPlayerLevel(client) + temp - 1, totalcount);
		for(new i = 0; i < totalcount ; i++){
			SetUpgrateLevel(client, i, 0, false, false);
		}
		CalculateFreePoints(client);	
	}
	
	ClientFreePoints[client] = temp;
}

/*
stock OverLoadLevel(client, overload, totalcount){
	new position;
	
	for(new i = 0; i < overload ; i++){
	 	//Adding a negative number is the same thing as subtractring...
	 	if(GetUpgrateLevel(client, position) > 0)
			SetUpgrateLevel(client, position, -1, true);
		
		position++;
		if(position > totalcount)
			position = 0;
	}
}
*/
