new LastRoundPoints[ MAXPLAYERS + 1];

//Get the level of a plyer
stock GetPlayerLevel(client){
 	new level, maxlevel;
 	maxlevel = GetConVarInt(g_cvars[CVAR_MAXLEVEL]);
 	level = GetLevelForXP( GetPlayerXP(client) );
 	
 	//if(level > maxlevel)
 	//	level = maxlevel;
	return level > maxlevel ? maxlevel : level;
}

//Set a player level
stock SetPlayerLevel(client , level, bool:add=false){
 	if(add)
 		level += GetPlayerLevel(client);
 	
 	
 	//Just to be on the safe side, lets +1
	SetPlayerXP(client, GetXPforLevel(level) + 1);
 
	CalculateFreePoints(client);
}

#define LEVEL_OFFSET 25
#define LEVEL_SQ 2.2
#define LEVEL_TOZERO 1297

stock GetXPforLevel(level){
	return RoundToFloor( Pow( float(level + LEVEL_OFFSET) , LEVEL_SQ) ) - LEVEL_TOZERO;
}

stock GetLevelForXP(xp){
	return RoundToFloor( Pow( float(xp + LEVEL_TOZERO) , 1.0 / LEVEL_SQ)) - LEVEL_OFFSET;
}

stock GivePlayersXP(){
 	#if DEBUG  == 1	
		LogMessage("Round restared called!");
	#endif
		
 	if(GetConVarInt(g_cvars[CVAR_MINPLAYERS]) > GetClientCount())
 		return;
 		
 	#if DEBUG  == 1	
		LogMessage("Passed player check!");
	#endif
 
	new leveltype = GetConVarInt(g_cvars[CVAR_LEVELTYPE]);
	if(leveltype > 0){
		for(new i = 1; i<= maxplayers; i++){
			if(!IsClientInGame(i))
				continue;
				
			if(GetClientTeam(i) == 2){
				SetPlayerLevel(i , leveltype, true);
				PrintToChat(i, "[ZMup] You have just won %d levels. You now have %d free points. Say !zmmenu to use them.", leveltype, Getfreepoints(i));
			}	
		}		
		return;
	}
	
 	new oldlevel, newlevel, deadxp, Float:multi, health, alivexp;
 	
 	deadxp = GetConVarInt(g_cvars[CVAR_DEAD]);
 	alivexp = GetConVarInt(g_cvars[CVAR_ALIVE]);
 	multi = GetConVarFloat(g_cvars[CVAR_XPMULTI]);
 	
 	
	for(new i = 1; i<= maxplayers; i++){
		if(!IsClientInGame(i))
			continue;
		
		#if DEBUG  == 1	
			LogMessage("-- %d - Points: %d | Health: %d | Alive: %d | Team: %d",i,GetClientFrags(i), GetClientHealth(i),IsPlayerAlive(i), GetClientTeam(i));
		#endif
			
		if(GetClientTeam(i) != 2)
			continue;
			
		oldlevel = GetPlayerLevel(i);
		health = GetClientHealth(i);
				
	 	if(health > 1){	
			SetPlayerXP(i, 
			RoundFloat( float ( health + (GetClientFrags(i) - LastRoundPoints[ i ]) + alivexp) * multi )
			, true);
		} else{
			SetPlayerXP(i, deadxp + (GetClientFrags(i) - LastRoundPoints[ i ]), true);
		}
		
		LastRoundPoints[ i ] = GetClientFrags(i);
		newlevel = GetPlayerLevel(i);
		
		if(newlevel != oldlevel){
			PrintToChat(i, "[ZMup] You have just won %d levels. You now have %d free points. Say !zmmenu to use them.", newlevel - oldlevel, Getfreepoints(i));
		}
	}
}

stock ResetPoints(client){
	LastRoundPoints[ client ] = 0;
}