#define VERSION "Beta#1"

#include <sourcemod>
#include <sdktools>
#include <zmup>

public Plugin:myinfo = 
{
	name = "ZM Sleep",
	author = "Nican",
	description = "",
	version = VERSION,
	url = "http://www.sourcemod.net/"
};

new ZMup_id = -1;

#define CVAR_LEVEL 0
#define CVAR_SPAWN 1
#define CVAR_AUTOINCREASE 2

#define CVAR_COUNT 3

new Handle:g_cvars[CVAR_COUNT];

public DB_OnRowsUpdated(){
	ZMup_id = ZM_StartUpgrate("zmup_MaxHealth", "Health Increase", "You will have more life", 20);
}

public OnPluginStart() 
{
	g_cvars[CVAR_LEVEL] = CreateConVar("sm_zm_extralife_level","1.4","How much life player will win per level");
	g_cvars[CVAR_SPAWN] = CreateConVar("sm_zm_extralife_spawn","1","Set this to 1 if player will respawn with that life");
	g_cvars[CVAR_AUTOINCREASE] = CreateConVar("sm_zm_extralife_auto","1","Set this to 1 if when players buy the upgrate their life will increase");
	
	
	HookEvent("player_spawn", PlayerSpawn);
	HookEvent("player_team", PlayerSpawn);
}



public PlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast){
	new client=GetClientOfUserId(GetEventInt(event,"userid"));
	
	if(!ZM_Check(client) || !GetConVarBool(g_cvars[CVAR_SPAWN]))
		return;
	
	new iLevel = ZM_GetLevel(client, ZMup_id);
	if(iLevel == 0)
		return;
		
	//LogMessage("Set %d life to : %d", client, RoundToFloor( GetConVarFloat(g_cvars[CVAR_LEVEL]) * iLevel ));
		
	ZM_SetHealth(client, RoundToFloor( GetConVarFloat(g_cvars[CVAR_LEVEL]) * iLevel ),true);
}

public DB_OnClientUpdate(client){
	RecalculateMaxHealth(client);	
}

public ZM_UpgradeUP(client, id, levels){
	if(id == ZMup_id)
		RecalculateMaxHealth(client);
		
	if(GetConVarBool(g_cvars[CVAR_AUTOINCREASE]))
		ZM_SetHealth(client, RoundToFloor( GetConVarFloat(g_cvars[CVAR_LEVEL]) * levels ),true);
}

stock RecalculateMaxHealth(client){
	ZM_SetMaxHealth(client, RoundToFloor( GetConVarFloat(g_cvars[CVAR_LEVEL]) * ZM_GetLevel(client, ZMup_id) ), true);
}

