#define VERSION "Beta#1"

#include <sourcemod>
#include <sdktools>
#include <zmup>

public Plugin:myinfo = 
{
	name = "ZM Sleep",
	author = "Nican",
	description = "",
	version = VERSION,
	url = "http://www.sourcemod.net/"
};

new ZMup_id = -1;

#define CVAR_START 0
#define CVAR_POWER 1
#define CVAR_REGEN 2
#define CVAR_HEALTH 3

#define CVAR_COUNT 4

new Handle:g_cvars[CVAR_COUNT], Handle:LoopTimer;

new IsSleeping[MAXPLAYERS + 1] = {0, ...};
new Float:OriginVelocity[ MAXPLAYERS + 1];
new SpeedOffset;

new maxplayers;

public DB_OnRowsUpdated(){
	ZMup_id = ZM_StartUpgrate("zmup_Sleep", "Sleep", "You regenarate your life while \nsleeping, you may not move while\nleeping.\n\nUse \"zmup_sleep\" on console to\nactivate/disactivate it", 20);
}

public OnPluginStart()
{
	g_cvars[CVAR_START] = CreateConVar("sm_zm_sleep_start","60","How much time (0.1sec) the player will take to regen 1 life");
	g_cvars[CVAR_POWER] = CreateConVar("sm_zm_sleep_lose","1","How much time (0.1sec) the player will lose per level");
	g_cvars[CVAR_REGEN] = CreateConVar("sm_zm_sleep_regen","1.0","How much health player will heal per loop");
	g_cvars[CVAR_HEALTH] = CreateConVar("sm_zm_sleep_perlevel","0.0","How much life player will heal extra per loop per level");
	
	SpeedOffset=FindSendPropOffs("CBasePlayer","m_flLaggedMovementValue");
	if(SpeedOffset==-1)
    	SetFailState("[ZMup] Error: Failed to find the Speed offset, aborting");
	
	HookEvent("player_death", PlayerDeath); 
	
	RegConsoleCmd("zmup_sleep", ToogleSleep);
}

public OnMapStart(){
	if(LoopTimer == INVALID_HANDLE){
		LoopTimer = CreateTimer(0.2, LoopThroughMinutes , 0, TIMER_REPEAT);
	}
	maxplayers = GetMaxClients();
}

public OnMapEnd(){
	KillTimer(LoopTimer);
	LoopTimer = INVALID_HANDLE;
	//LogMessage("Loop killed");
}

public OnClientAuthorized(client){
 	IsSleeping[client] = 0;
}

public OnClientDisconnect(client){
	IsSleeping[client] = 0;
}

public PlayerDeath(Handle:event,const String:name[],bool:dontBroadcast){
	new client=GetClientOfUserId(GetEventInt(event,"userid"));
	if(IsSleeping[client] > 0){
		set_rendering(client);	
		IsSleeping[client] = 0;
	}
}

public Action:LoopThroughMinutes(Handle:timer,any:index)
{ 	
	for(new i = 1; i <= maxplayers ; i ++){
		if(!IsClientInGame(i))
			continue;
		
		if(IsSleeping[i] == 0)
			continue;
			
		IsSleeping[i] += 2;
		
		//I simply hate to have to call this every second, but I find no other way
		//I wish there was a way to disable FADE on the middle
		if((IsSleeping[i] % 10) == 0){
			UTIL_ScreenFade(i);
		}
	}
}

public Action:ToogleSleep(client, args){
	if(ZMup_id == -1)
		return Plugin_Handled;
		
	if(!ZM_Check(client,true))
		return Plugin_Handled;
	
	new iLevel = ZM_GetLevel(client, ZMup_id);

	if(IsSleeping[client] > 0){
	 	//(Times of 0.1 / (start - (perlevel * level))) * (RegenLevel + (Perlevel * level))
		new newhealth = RoundFloat(
			(float(IsSleeping[client]) / 
				float(GetConVarInt(g_cvars[CVAR_START]) - (GetConVarInt(g_cvars[CVAR_POWER]) * iLevel))
			) * (GetConVarFloat(g_cvars[CVAR_REGEN]) + (GetConVarFloat(g_cvars[CVAR_HEALTH]) * iLevel))
		);
		
		//I really need to debug that, such a large equasion...
		PrintToChat(client, "[ZMup] You have just earned %d health", newhealth);
		ZM_SetHealth(client, newhealth, true);
		
		SetEntDataFloat(client, SpeedOffset, OriginVelocity[ client ],true);
		set_rendering(client);		
		
		IsSleeping[client] = 0;
	} else {
		if(iLevel == 0){
			PrintToChat(client, "[ZMup] You don't have any points on Sleep");
			return Plugin_Handled;
		}
		
		if(!(GetEntityFlags(client) & FL_ONGROUND)){
            PrintToChat(client, "[ZMup] You are not on stable floor");
            return Plugin_Handled;        
        }
		
		//Just to make sure I will be not settings a stupid random number later
		OriginVelocity[client] = GetEntDataFloat(client,SpeedOffset);	
		
		SetEntDataFloat(client,SpeedOffset,0.0,true);
		set_rendering(client, RENDERFX_GLOWSHELL, 255, 255, 255, RENDER_GLOW, 255);	
		UTIL_ScreenFade(client);
		IsSleeping[client] = 1;
	}
	return Plugin_Handled;
}

stock set_rendering(index, RenderFx:fx=RENDERFX_NONE, r=255, g=255, b=255, RenderMode:render=RENDER_NORMAL, amount=255)
{
	/*SetEntProp(index, Prop_Send, "m_nRenderFX", _:fx, 1);
	SetEntProp(index, Prop_Send, "m_nRenderMode", _:render, 1);

	new offset = GetEntSendPropOffs(index, "m_clrRender");
	
	SetEntData(index, offset, r, 1, true);
	SetEntData(index, offset + 1, g, 1, true);
	SetEntData(index, offset + 2, b, 1, true);
	SetEntData(index, offset + 3, amount, 1, true); */
	
	SetEntityRenderColor(index, r,g,b, amount);
	SetEntityRenderFx(index, fx);
	SetEntityRenderMode(index, render);
}

UTIL_ScreenFade(client, duration=22, time=0, flags=0, r=0, g=0, b=0, a=255)
{
   new clients[1], Handle:bf;
   clients[0] = client;

   bf = StartMessage("Fade", clients, 1);
   BfWriteShort(bf, duration);
   BfWriteShort(bf, time);
   BfWriteShort(bf, flags);
   BfWriteByte(bf, r);
   BfWriteByte(bf, g);
   BfWriteByte(bf, b);
   BfWriteByte(bf, a);
   EndMessage();
}
