#define VERSION "Beta#1"

#include <sourcemod>
#include <sdktools>
#include <zmup>

public Plugin:myinfo = 
{
	name = "ZM Super Jump",
	author = "Nican",
	description = "",
	version = VERSION,
	url = "http://www.sourcemod.net/"
};

new ZMup_id = -1;
new vecVelocity;

#define CVAR_START 0
#define CVAR_POWER 1
#define CVAR_UP 2
#define CVAR_HEALTH 3
#define CVAR_HEALTHLEVEL 4

#define CVAR_COUNT 5

new Handle:g_cvars[CVAR_COUNT];
new Float:g_cvars_value[CVAR_COUNT];

public DB_OnRowsUpdated(){
	ZMup_id = ZM_StartUpgrate("zmup_SuperJump", "Super jump", "You will be able to jump on far \nplaces and losing heath for each use\n\nUse \"zmup_jump\" on console to\nactivate it", 20);
}

public OnPluginStart() 
{
	g_cvars[CVAR_START] = CreateConVar("sm_zm_jump_start","30.0","How much power the player will start with");
	g_cvars[CVAR_POWER] = CreateConVar("sm_zm_jump_power","18.0","How much power per level the jump will have");
	g_cvars[CVAR_UP] = CreateConVar("sm_zm_jump_upmulti","0.15","How much power will go to the Z axis");
	g_cvars[CVAR_HEALTH] = CreateConVar("sm_zm_jump_health","1.0","How much life player will lose per use");
	g_cvars[CVAR_HEALTHLEVEL] = CreateConVar("sm_zm_jump_healthlevel","0.0","How much extra life player will lose per level");
	
	
	for(new i = 0; i<CVAR_COUNT; i++)
		HookConVarChange(g_cvars[i], ConvarChanged);
	
	ReloadCvars();
	
	vecVelocity=FindSendPropOffs("CBasePlayer","m_vecVelocity[0]");
	if(vecVelocity==-1)
    	SetFailState("[RollTheDice:Commands] Error: Failed to find the velocity offset, aborting");
	
	RegConsoleCmd("zmup_jump", SuperJump);
}

public ConvarChanged(Handle:convar, const String:oldValue[], const String:newValue[]){
	ReloadCvars();
}

stock ReloadCvars(){
 	for(new i = 0; i<CVAR_COUNT; i++)
		g_cvars_value[i] = GetConVarFloat(g_cvars[i]);
		
	g_cvars_value[CVAR_UP] = -g_cvars_value[CVAR_UP];
	g_cvars_value[CVAR_HEALTH] = -g_cvars_value[CVAR_HEALTH];
	g_cvars_value[CVAR_HEALTHLEVEL] = -g_cvars_value[CVAR_HEALTHLEVEL];
}

public Action:SuperJump(client, args){
	if(ZMup_id == -1)
		return Plugin_Handled;
		
	if(!ZM_Check(client,true))
		return Plugin_Handled;

 	new iLevel = ZM_GetLevel(client, ZMup_id);
	if(iLevel == 0){
		PrintToChat(client, "[ZMup] You don't have any points on SuperJump");
		return Plugin_Handled;
	}
	
	// Start + (Power * level)
	new Float:stengh = FloatAdd( g_cvars_value[CVAR_START] , FloatMul( g_cvars_value[CVAR_POWER] , float(iLevel)));

 
	new Float:vAngles[3], Float:vReturn[3];	
	GetEntDataVector(client, vecVelocity, vReturn);
	GetClientEyeAngles(client, vAngles);
	
	vAngles[1] = DegToRad(vAngles[1]);
	
	vReturn[0] = ( Cosine(vAngles[1]) * stengh ) + vReturn[0];
	vReturn[1] = ( Sine(vAngles[1])   * stengh ) + vReturn[1];
	vReturn[2] = ( Sine(DegToRad(vAngles[0]))  * stengh * g_cvars_value[CVAR_UP] ) + vReturn[2];
	
	/* PrintToChat(client, "[ZMup] Superjump: %f", stengh);
	PrintToChat(client, "[ZMup] x: %f", vReturn[0]);
	PrintToChat(client, "[ZMup] y: %f", vReturn[1]);
	PrintToChat(client, "[ZMup] z: %f", vReturn[2]); */
		
	TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vReturn);
	ZM_SetHealth(client, RoundFloat(g_cvars_value[CVAR_HEALTH] + (g_cvars_value[CVAR_HEALTHLEVEL] * iLevel)), true);
	
	return Plugin_Handled;
}
